/*******************************************************************************
   Moduli:        kahvat.cpp
   Tarkoitus:     Luokka, johon talletetaan cMuunnettuIkkunat
                  eli alkukuva- ja kuvaikkunat.
   Projekti:      Winlin, Cum laude approbatur -harjoitusty
   Tekijt:       Virpi Kivinen & Tiina Mkinen
   Tehty:         1.1.96
   Muutettu       1.7.96
   Mit muutettu: + listtyyt
   Muutettu       22.8.96
   Mit muutettu: + Aseta_aktiivinen(), anna_aktiivinen()

   Puutteet:      mkki

  cKahvat-luokan metodit:
    - cMuunnettuIkkuna *etsi(HWND hwnd)
        Palauttaa osoitintaulukosta annettua kahvaa
        vastaavan osoittimen ikkunaan.
    - HWND etsi_kahva(int kahva)
        Palauttaa taulukosta parametrina tuodussa paikassa olevan
        ikkunan kahvan.
    - int kopioi_taulukko(cKahvat &kahva)
    - cKahvat &operator=(cKahvat &kahva)
    - cMuunnettuIkkuna *ensimmainen(void)
    - cMuunnettuIkkuna *seuraava(void)
    - int lisaa(HWND h, HINSTANCE i,int paikka,char *otsikko,char *luokka,WNDPROC KuvaWndProc)
        Luo pikkunaan DoClassWindowCmd -aliohjelmalla lapsi_ikkunoita.
        Parametrina tuodaan pikkuna h, sen esiintym i, taulukon paikka,
        ikkunan otsikko, luokka ja ksittelijfunktio, jotka vlitetn
        edelleen DoClassWindowCmd aliohjelmalle.  Tallettaa DoClassWindowCmd:n
        palauttaman ikkunan kahvan paikkaan Paikka taulukossa HWND Hwndt[].
        Varaa new:ll uuden cMuunettuIkkuna:n,jolle annetaan luotaessa juuri
        edell saatu kahva. Saatu osoitin sijoitetaan cMuuunnettuIkkuna
        *Ikkunat[] -osoitintaulukkoon.
    - int  muuta_koko(HWND hWnd)
        Kutsuu silmukassa muuta_lapset aliohjelmaa,
        hWnd ---> isahwnd , Kahvat[i] --->lapsihwnd.
    - int tuhoa(void)
        Tuhoaa new:ll luodut cMuunnettuIkkunat silmukassa. Nollaa samalla
        ikkunoiden kahvat.
    - int Aseta_aktiivinen(HWND h)
        Laittaa aktiiviseksi ikkunan, jolla on sama kahva kuin parametrina
        tuotu h.
    - HWND anna_aktiivinen(void)
        Palauttaa aktiivisena olevan ikkunan kahvan.

  Muut aliohjelmat:
    - static LONG muuta_lapset(HWND isahwnd,HWND lapsihwnd,int kuka)
        Muuttaa pikkunan (Lineaarikuvaus) lapsi-ikkunat oikeaan kokoon
        suhteessa pikkunaan.

**************************************************************************/

#include<windows.h>
#include<windowsx.h>
#include"kahvat.h"
#include"mdialog.h"
#include"tabhand.h"
#include"winlin.h"

cMuunnettuIkkuna *cKahvat::etsi(HWND hwnd)
{
  int i;
  HWND h;

  for (i=0;i<MAX_IKKUNOITA;i++) {
    h=Ikkunat[i]->Kahva();
    if (h == hwnd) return Ikkunat[i];
  }
  return NULL;
}

HWND cKahvat::etsi_kahva(int paikka)
{
  if (paikka<0||lkm<=paikka) return Kahvat[0];
  return Kahvat[paikka];
}

int cKahvat::kopioi_taulukko(cKahvat &kahva)
{
  int i;
  cMuunnettuIkkuna *p;

  tuhoa();

  lkm=kahva.lkm;
  for (i=0; i<MAX_IKKUNOITA; i++){
    p=new cMuunnettuIkkuna();
    *p=*kahva.Ikkunat[i];
    Ikkunat[i]=p;
  }
  return 0;
}

cKahvat &cKahvat::operator=(cKahvat &kahva)
{
  if ( &kahva==this )return *this;
  kopioi_taulukko(kahva);
  return *this;
}

cMuunnettuIkkuna *cKahvat::ensimmainen(void)
{
  return Ikkunat[0];
}

cMuunnettuIkkuna *cKahvat::seuraava(void)
{
  static int apu=lkm;
  if(apu<1) {apu=lkm; }//return NULL;}
  cMuunnettuIkkuna *I = Ikkunat[lkm-apu+1];
  apu--;
  return I;
}

static LONG muuta_lapset(HWND isahwnd,HWND lapsihwnd,int kuka)
{
  RECT Rct;
  InvalidateRect(isahwnd,NULL,TRUE);
  GetClientRect(isahwnd,&Rct);
  switch (kuka) {
    case 0:  MoveWindow(lapsihwnd,UUSIALKU,TRUE); break;
    case 1:  MoveWindow(lapsihwnd,UUSIKUVA,TRUE); break;
  }
  MoveWindow(W.Hwndt[2],UUSITK,TRUE);
  MoveWindow(W.Hwndt[1],Rct.right+30,30,W.dimensio*(W.Rct.right+10),W.dimensio*(W.Rct.bottom+5)+30,TRUE);
  return 0;
}

int cKahvat::lisaa(int a,HWND h,HINSTANCE i,int paikka,char *otsikko,char *luokka,WNDPROC KuvaWndProc)
{
  if (lkm>=MAX_IKKUNOITA-1) return 1;
  Kahvat[paikka]=DoClassWindowCmd(i,luokka,0,h,otsikko,KuvaWndProc,
                         WS_CAPTION | WS_THICKFRAME | WS_CHILD | WS_CLIPSIBLINGS ,
                         SW_SHOW,SetAlkuwc);
  muuta_lapset(h,Kahvat[paikka],paikka);

  Ikkunat[paikka]=new cMuunnettuIkkuna(a,Kahvat[paikka],paikka);
  lkm++;
  Ikkunat[lkm]=NULL;
  return 0;
}

int  cKahvat::muuta_koko(HWND hWnd)  //lasten koko aina suhteessa pikkunaan
{
  int i;
  for (i=0; i<lkm; i++)
    muuta_lapset(hWnd,Kahvat[i],i);
  return 0;
}

int cKahvat::tuhoa(void)
{
  int i;
  for (i=0;i<lkm;i++) {
    delete Ikkunat[i];
    Ikkunat[i]=NULL;
    Kahvat[i]=0;
  }
  lkm=0;
  return 0;
}

int cKahvat::Aseta_aktiivinen(HWND h)
{
  int i,j; char s[12]; char apu[15];
  for(i=0;i<lkm;i++){
    GetWindowText(Ikkunat[i]->Kahva(),s,15);
    if(Ikkunat[i]->Kahva()==h) {
      if(s[0]!='x') s[0]='x';
      Ikkunat[i]->aseta_aktiivinen(1);
    }
    else {
      if(s[0]!=' ') s[0]=' ';
      Ikkunat[i]->aseta_aktiivinen(0);
    }
    for(j=0;j<sizeof(s);j++)
      apu[j]=s[j];
    SetWindowText(Ikkunat[i]->Kahva(),apu);
  }
  return 0;
}

HWND cKahvat::anna_aktiivinen(void)
{
  int i;
  for(i=0;i<lkm;i++) {
    if (Ikkunat[i]->Aktiivinen()) return Ikkunat[i]->Kahva();
  }
  return NULL;
}
