/*******************************************************************************
   Moduli:        matrix.cpp
   Tarkoitus:     ......
   Projekti:      Winlin, Cum laude approbatur -harjoitusty
   Tekijt:       Virpi Kivinen & Tiina Mkinen
   Tehty:         1.1.96
   Muutettu       1.7.96
   Mit muutettu: + listtyyt
   Muutettu       23.10.96 / vl
   Mit muutettu: + matriisi ei mene ruudun ulkopuolelle
   Puutteet:      mkki

*************************************************************************
static LONG WM_initdialog(tMSGParam *msg)
  -Matriisi alustetaan 2*2-matriisiksi.
static LONG WM_command_NAPSI_LUVUT(tMSGParam *msg)
  -Ker matriisi-ikkunasta kertoimet matriisiin a.
   Kutsuu aliohjelmaa napsi_luvut(cMatrix &a,HWND hwnd), joka ky matriisin
   lpi kaksinkertaisessa silmukassa ja lukee kertoimet kustakin matriisin
   paikasta vastaavaan a:n paikkaan aliohjelmalla lue_kerroin(...).

   Kertoo saadulla matriisilla (I->muunna(a)) cMuunnettuIkkunan (Kuva)
   Muunnos-matriisia. Ennen kertomista palauttaa ikkunan Muunnos-
   matriisin aina yksikkmatriisiksi. Lhett Kuvalle (h) viestin KUVAA.
static LONG WM_command_i_matr(tMSGParam *msg)
  -Kutsuu aliohjelmaa aseta_matriisi(...) yksikkmatriisilla.
static LONG WM_command_liiku(tMSGParam *msg)
  -Muuttaa kursorin paikkaa matriisin alkiosta toiseen, kun on painettu jotain
   nuolinppint.
static LONG WM_command_dim(tMSGParam *msg)
  -Muuttaa matriisin kokoa (2*2, 3*3 tai 4*4). Se vaihtaa piirtodimensiota.
int aseta_matriisi(cMatrix &A,HWND hwnd)
  -Sijoittaa kuvausmatriisiin parametrina tuodun matriisin A. Lhett
   KUVAA-viestin.
char *vaihda(char *s,int n,char *mika, char *miksi)
  -Vaihtaa s:st kaikki mikat miksiksi. (Kytetn vaihtamaan matriisin
   alkioissa pilkut pisteiksi.)
int lue_kerroin(int id,int rivi,int sarake,HWND hWnd,cMatrix &a)
  -Lukee kuvausmatriisin alkion paikasta [rivi][sarake] ja sijoittaa sen
   parametrina tuodun matriisin a samaan paikkaan.
int napsi_luvut(cMatrix &a,HWND hwnd)
  -Lukee koko kuvausmatriisin kutsuen aliohjelmaa lue_kerroin(...).
   Matriisi luetaan parametrina tuotuun matriisiin a.
int kerro_matriisi(cMatrix &R)
  -R=R*kuvausmatriisi. Kuvausmatriisi luetaan aliohjelmalla napsi_luvut(...).
   Kytetn valmiiden kuvauksien yhdistetyiss kuvauksissa.
int tee_kaksi_ulotteinen(HWND hwnd,int nakyyko,BOOL saako)
  -Tekee kuvausmatriisista 2-ulotteisen. Tekee siit neliulotteisen, jos
   nakyyko=SW_SHOW (matriisin alkio on nkyviss) ja saako=TRUE (saako
   alkioon kirjoittaa).
int tee_kolmi_ulotteinen(HWND hwnd,int nakyyko,BOOL saako)
  -Tekee matriisista kolmiulotteisen.
***************************************************************************/

#include<windows.h>
#include<windowsx.h>
#include<stdio.h>
#include"tabhand.h"
#include"mdialog.h"
#include"mjonot.h"
#include"kahvat.h"
#include"winlin.h"

int aseta_matriisi(cMatrix &A,HWND hwnd)
{
  int i,j,k=0;
  HWND h; char s[10];
  cMuunnettuIkkuna *I;

  h=ikkunat.etsi_kahva(1);
  I=ikkunat.etsi(h);

  for(i=0;i<KOKO;i++)           //matriisin rivit
    for(j=0;j<KOKO;j++) {       //matriisin sarakkeet
      if (A[i][j]<EPSILON && -EPSILON<A[i][j]) A[i][j]=0.0;
      sprintf(s,"%lg",A[i][j],sizeof(s));
      SetDlgItemText(hwnd,IDC_EDIT11+k,s);
      k++;
    }
  I->palauta(A);
  LAHETA_VIESTI(h,KUVAA) //muunnosmatriisissa on nyt dialogiin kirjoitettu matriisi
  return 0;
}

char *vaihda(char *s,int n,char *mika, char *miksi)
{
  int i;
  for (i=0; i<n; i++)
    if ( s[i] == *mika ) s[i] = *miksi;
  return s;
}

int lue_kerroin(int id,int rivi,int sarake,HWND hWnd,cMatrix &a)
{
  char s[40];

  GetDlgItemText(hWnd,id,s,sizeof(s));
  poista_merkit(s," ");   //mjonot.c
  vaihda(s,sizeof(s),",",".");
  if (sscanf(s,"%lg",&a[rivi][sarake])!=1) {
    if (rivi==sarake) a[rivi][sarake]=1.0;
    else a[rivi][sarake]=0.0;
  }
  sprintf(s,"%lg",a[rivi][sarake]);
  SetDlgItemText(hWnd,id,s);

  return 0;
}

int napsi_luvut(cMatrix &a,HWND hwnd)
{
  int i,j,k=0;
  for(i=0;i<KOKO;i++)           //matriisin rivit
    for(j=0;j<KOKO;j++) {       //matriisin sarakkeet
      lue_kerroin(IDC_EDIT11+k,i,j,hwnd,a);
      k++;
    }
  return 0;
}

int kerro_matriisi(cMatrix &R)
{
  cMatrix A;
  napsi_luvut(A,W.Hwndt[1]);
  R*=A;    //tai R=A*R;
  return 0;
}

int tee_kaksi_ulotteinen(HWND hwnd,int nakyyko,BOOL saako)
{        //tytyy laittaa dimensio korjuun!!!
  HWND h;
  int i;

  h=GetDlgItem(hwnd,IDC_EDIT13);
  ShowWindow(h,nakyyko);
  EnableWindow(h,saako);
  h=GetDlgItem(hwnd,IDC_EDIT14);
  ShowWindow(h,nakyyko);
  EnableWindow(h,saako);

  for(i=IDC_EDIT23; i<=IDC_EDIT44; i++){
    h=GetDlgItem(hwnd,i);
    ShowWindow(h,nakyyko);
    EnableWindow(h,saako);
  }

  return 0;
}

int tee_kolmi_ulotteinen(HWND hwnd,int nakyyko,BOOL saako)
{
  HWND h;
  int i;

  tee_kaksi_ulotteinen(hwnd,SW_SHOW,TRUE);

  h=GetDlgItem(hwnd,IDC_EDIT14);
  ShowWindow(h,nakyyko);
  EnableWindow(h,saako);
  h=GetDlgItem(hwnd,IDC_EDIT24);
  ShowWindow(h,nakyyko);
  EnableWindow(h,saako);

  for (i=IDC_EDIT34; i<=IDC_EDIT44; i++){
    h=GetDlgItem(hwnd,i);
    ShowWindow(h,nakyyko);
    EnableWindow(h,saako);
  }

  return 0;
}

static LONG WM_command_NAPSI_LUVUT(tMSGParam *msg)
{
  HWND h;
  cMatrix a;
  cMuunnettuIkkuna *I;

  h=ikkunat.etsi_kahva(1);
  I=ikkunat.etsi(h);

  napsi_luvut(a,msg->hWnd);
  I->palauta(a);
  LAHETA_VIESTI(h,KUVAA)    //muunnosmatriisissa on nyt dialogiin kirjoitettu matriisi

  return 0;
 }

static LONG WM_command_i_matr(tMSGParam *msg)
{
  aseta_matriisi(cMatrix(1),msg->hWnd);
  SetFocus(msg->hWnd);
  return 0;
}

static LONG WM_command_liiku(tMSGParam *msg)
{
  HWND hwnd=GetFocus();
  int id=GetDlgCtrlID(hwnd);
  switch (msg->id){
    case OIKEALLE:
      if (id==IDC_EDIT44) id -=16;
      hwnd=GetDlgItem(msg->hWnd,id+1);   break;
    case VASEMMALLE:
      if (id==IDC_EDIT11) id +=16;
      hwnd=GetDlgItem(msg->hWnd,id-1);   break;
    case YLOS:
      if (IDC_EDIT11<=id&&id<=IDC_EDIT14) id +=16;
      hwnd=GetDlgItem(msg->hWnd,id-4);   break;
    case ALAS:
      if (IDC_EDIT41<=id&&id<=IDC_EDIT44) id -=16;
      hwnd=GetDlgItem(msg->hWnd,id+4);   break;
  }
  SetFocus(hwnd);  Edit_SetSel(hwnd,0,-1);
  return 0;
}

static LONG WM_command_dim(tMSGParam *msg)
{
  RECT MRct;
  GetWindowRect(msg->hWnd,&MRct);
  switch (msg->id){
    case CM_2D:
        W.dimensio=2;
        tee_kaksi_ulotteinen(msg->hWnd,SW_HIDE,FALSE);
        break;
    case CM_3D:
        W.dimensio=3;
        tee_kolmi_ulotteinen(msg->hWnd,SW_HIDE,FALSE);
        break;
    case CM_4D:
        W.dimensio=4;
        tee_kaksi_ulotteinen(msg->hWnd,SW_SHOW,TRUE);
        break;
  }   //matriisi oikean kokoiseksi ,oikeaan paikkaan suhteessa pikkunaan
  MoveWindow(msg->hWnd,MRct.left,MRct.top,W.dimensio*(W.Rct.right+10),
             W.dimensio*(W.Rct.bottom+5)+30,TRUE);
  LAHETA_VIESTI(ikkunat.etsi_kahva(0),PIIRRA);
  LAHETA_VIESTI(ikkunat.etsi_kahva(1),PIIRRA);
  return 0;
}

static LONG WM_initdialog(tMSGParam *msg)
{
  RECT Rct;
  int x,y,sx;
  sx = GetSystemMetrics(SM_CXSCREEN);
  GetWindowRect(W.Hwndt[0],&Rct);
  x = Rct.right;  if ( x > sx ) x = sx - 100;
  y = Rct.top;
  MoveWindow(msg->hWnd,x,y,30,30,TRUE);
  tee_kaksi_ulotteinen(msg->hWnd,SW_HIDE,FALSE);
  return 0;
}

tMSGEntry MatTbl[] = {
  { WM_INITDIALOG , DoC   ,       DoC , WM_initdialog },
  { WM_COMMAND    , IDOK  ,       DoC , WM_command_NAPSI_LUVUT },
  { WM_COMMAND    , I_MATR,       DoC , WM_command_i_matr },
  { WM_COMMAND    , TRANGE,       DoC , WM_command_liiku ,0,0,ALAS,OIKEALLE},
  { WM_COMMAND    , TRANGE,       DoC , WM_command_dim,0,0,CM_2D,CM_4D  },
  { 0 }
};

