/*******************************************************************************
   Moduli:        muunnik.cpp
   Tarkoitus:     Valmis luokka cMuunnettuIkkuna, jonka on tarkoitus helpottaa
                  Windowsin ikkunaan piirtmist.
     class cMuunnettuIkkuna{
         HWND hwnd;               -ikkunan kahva
         HPEN hpen,old;           -kyn, jolla piirretn
         RECT Rct;                -ikkunan koko
         cMatrix Origo;           -siirretty keskipiste
         int xstep, xjako, yjako; -jakovlin pituus ja lukumrt
         double fc,dx,dy;         -pikselin kerroin, ikkunan puolikkaat
         cMatrix Muunnos, Apu;    -kuvaus-, koordinaatiston piirtomatriisi
         int jako;                -puolikkaan akselin jakovlien lukumr
         int kuva;                -onko kuvaikkuna
         int aktiivinen;          -kumpi ikkunoista on aktiivisena
         HDC hdc;                 -laiteyhteys
      }
   Projekti:      Winlin, Cum laude approbatur -harjoitusty
   Tekijt:       Virpi Kivinen & Tiina Mkinen
   Tehty:         1.1.96
   Muutettu       1.7.96
   Mit muutettu: + listtyyt
   Muutettu       8.8.96
   Mit muutettu: + HDC cMuunnettuIkkuna::Hdc(void),joka palauttaa hdc:n
                    aseta_piirretaan(...) ja piirretaanko(...) poistettu
                    tarpeettomina
   Puutteet:      tarkistuksia metodeihin.
                  verkko, jota tuskin kannattaa piirt 3-ulotteisena
                  (piirra_jako(...))

  cMuunnettuIkkuna-luokan metodit:
   - int cMuunnettuIkkuna::aseta_hdc(HDC Hdc)
       Parametrina tuotu Hdc sijoitetaan luokan hdc:hen, jota kytetn
       kaikissa piirroissa.
   - int cMuunnettuIkkuna::aseta_jako(void)
       Tekee uuden Origo-matriisin (Origo siirt origon ylnurkasta keskelle).
   - int cMuunnettuIkkuna::tarkistus(cVec &b)
       Tarkistetaan, onko vektorin viimeinen alkio 1. Jos ei, niin sill
       jaetaan kaikki vektorin alkiot. Jos se on nolla, niin muihin vektorin
       alkioihin sijoitetaan iso luku ja viimeiseen 1.
       Tm kaikki perspektiivi varten.
   - int cMuunnettuIkkuna::move(const cVec &y1)
       Siirt kynn annettuun pisteeseen. Muuttaa sit varten y1:n pikse-
       leiksi. Vrt. MoveToEx
   - int cMuunnettuIkkuna::line(const cVec &y1)
       Vet viivan thn pisteeseen, muuttaa y1:n pikseleiksi.
       Vrt. LineTo
   - int cMuunnettuIkkuna::text(const cVec &y1,const char *s)
       s:ss oleva teksti kirjoitetaan koordinaatistoon vektorin y1
       osoittamaan paikkaan.
   - int cMuunnettuIkkuna::line(const cJana &j)
       Piirretn jana j, jossa on alku- ja loppupiste reaalivektoreina.
   - double cMuunnettuIkkuna::Jako(void)
       Palauttaa luokan muuttujan jako.
   - int cMuunnettuIkkuna::Kuva(void)
       Palauttaa, onko ikkuna kuva- vai alkukuvaikkuna.
   - HWND cMuunnettuIkkuna::Kahva(void)
       Palauttaa ikkunan kahvan.
   - int cMuunnettuIkkuna::muuta_step(const int muutos)
       Muuttaa jakovlin pituutta muutoksen verran. Tehdn, kun on zoomailtu
       kuvaikkunaa.
   - cMatrix cMuunnettuIkkuna::muunna(const cMatrix &H)
       Kertoo ikkunan matriisin (Muunnos) H:lla ja palauttaa entisen matriisin.
   - cMatrix cMuunnettuIkkuna::sijoita(cMatrix &A)
       Kertoo koordinaatistoon vaikuttavaa Apu-matriisia A:lla. Palauttaa
       vanhan Apu-matriisin.
   - cMatrix cMuunnettuIkkuna::yksikkom(void)
       Tekee Muunnos-matriisista yksikkmatriisin. Palauttaa vanhan Muunnos-
       matriisin. Kutsutaan ainakin koordinaatiston piirrossa, koska ne piirre-
       tn "suoraan" eik kuvattuna.
   - cMatrix cMuunnettuIkkuna::yksikkokoord(void)
       Tekee Apu-matriisista yksikkmatriisin. Palauttaa vanhan Apu-
       matriisin.
   - int cMuunnettuIkkuna::kaanna_o(cMatrix &apu)
       Knt matriisin, joka siirt origon keskelle. Ei toimi muille
       matriiseille.
   - cVec cMuunnettuIkkuna::vektori_reaaliksi(cVec &a )
       Tekee pikselivektorista reaalivektorin.
   - int cMuunnettuIkkuna::palauta(const cMatrix &A)
       Sijoittaa parametrina tuodun matriisin A Muunnos-matriisiin.
   - int cMuunnettuIkkuna::piirra_jako(const cVec &place,const int axel,const int verkko)
       Piirt jakoviivat koordinaattiakseleihin. Jos verkko on valittuna
       menussa, niin tss piirretn sekin.
   - int cMuunnettuIkkuna::koordinaatisto(const cVec &place, int axel, HPEN kyna,const int verkko)
       Piirt axel:in osoittaman koordinaattiakselin.
   - void cMuunnettuIkkuna::luo_kyna(HPEN pen)
       Vaihtaa kynksi parametrina tuodun pen-kynn.
       Laittaa vanhan talteen old:iin.
   - void cMuunnettuIkkuna::poista_kyna(void)
       Vaihtaa kynn takaisin old:ksi ja laittaa edellisen kynn hpen:iin.
       Tt kytetn pareittain luo_kyna(...)-metodin kanssa.
   - int cMuunnettuIkkuna::aseta_aktiivinen(int a)
       Sijoittaa aktiiviseen a:n.
   - int cMuunnettuIkkuna::Aktiivinen(void)
       Palauttaa aktiivisen.

  Muut aliohjelmat:
   - int round(double d)
       Pyrist reaaliluvun lhimpn kokonaislukuun.

*************************************************************************/
#include<windows.h>
#include<windowsx.h>
#include<string.h>
#include"muunnik.h"

int round(double d)
{
  if ( d < 0 ) return (int)(d-0.5);
  return (int)(d+0.5);
}

int cMuunnettuIkkuna::aseta_hdc(HDC Hdc)
{
  hdc=Hdc;
  return 0;
}

int cMuunnettuIkkuna::aseta_jako(void)
{
  GetClientRect(hwnd,&Rct);
  dx=Rct.right/2;
  dy=Rct.bottom/2;
  xjako=dx/xstep;
  yjako=dy/(fc*xstep);
  if (xjako > yjako) jako = yjako; else jako = xjako;
  Origo.tee_muunnos(xstep,dx,dy,fc);
  return 0;
}

int cMuunnettuIkkuna::tarkistus(cVec &b) //perspektiivi: b[3]!=1
{
  int i;
  if(-EPSILON<b[3]&&b[3]<EPSILON) {
    for(i=0;i<KOKO;i++) b[i]=ISO_LUKU;
    b[3]=1;
  }
  if(b[3]!=1)
    for(i=0;i<KOKO;i++) b[i]=b[i]/b[3];
  b[0]=round(b[0]); b[1]=round(b[1]);

  return 0;
}

int cMuunnettuIkkuna::move(const cVec &y1)
{
  cVec b;
  b=Origo*Apu*Muunnos*y1;
  tarkistus(b);
  MoveToEx(hdc,b[0],b[1],NULL);
  return 0;
}

int cMuunnettuIkkuna::line(const cVec &y1)
{
  cVec b;
  b=Origo*Apu*Muunnos*y1;
  tarkistus(b);
  LineTo(hdc,b[0],b[1]);
  return 0;
}

int cMuunnettuIkkuna::text(const cVec &y1,const char *s)
{
  cVec b;
  b=Origo*Apu*Muunnos*y1;
  tarkistus(b);
  SetTextColor(hdc,RGB(255,255,255));//color[6]);    // aliohjelmaan!!
  SetBkColor(hdc,RGB(0,0,0));//color[0,0,0]);
  TextOut(hdc,b[0],b[1],s,strlen(s));
  return 0;
}

int cMuunnettuIkkuna::line(const cJana &j)
{
  cVec b;
  b=Origo*Apu*Muunnos*j.ap;
  tarkistus(b);
  MoveToEx(hdc,b[0],b[1],NULL);
  b=Origo*Apu*Muunnos*j.lp;
  tarkistus(b);
  LineTo(hdc,b[0],b[1]);
  return 0;
}

double cMuunnettuIkkuna::Jako(void)
{
  return (double)jako;
}

HDC cMuunnettuIkkuna::Hdc(void)
{
  return hdc;
}

int cMuunnettuIkkuna::Kuva(void)
{
  return kuva;
}

HWND cMuunnettuIkkuna::Kahva(void)
{
  return hwnd;
}

int cMuunnettuIkkuna::muuta_step(const int muutos)
{
  xstep+=muutos;
  if (xstep<=0||muutos==0) {
    xstep=XSTEP;
    if (xstep<=0)
      MessageBox(hwnd,"Jakovlin pituus meni nollaksi!","Lineaarikuvaus",MB_APPLMODAL|MB_OK);
  }
  return 0;
}

cMatrix cMuunnettuIkkuna::muunna(const cMatrix &H)
{
  cMatrix apu(Muunnos);
  Muunnos *= H;
  return apu;
}

cMatrix cMuunnettuIkkuna::sijoita(cMatrix &A)
{
  cMatrix B(Apu);
  Apu *= A;
  return B;
}

cMatrix cMuunnettuIkkuna::yksikkom(void)
{
  cMatrix apu(Muunnos);
  Muunnos.diagonaali();
  return apu;
}

cMatrix cMuunnettuIkkuna::yksikkokoord(void)
{
  cMatrix apu(Apu);
  Apu.diagonaali();
  return apu;
}

int cMuunnettuIkkuna::kaanna_o(cMatrix &apu)  //kaanteismatriisi sijoitetaan, ei lasketa!!!
{
  apu[0][0] = 1.0/Origo[0][0]; apu[0][3] = -Origo[0][3]/Origo[0][0];
  apu[1][1] = 1.0/Origo[1][1]; apu[1][3] =  -Origo[1][3]/Origo[1][1];
  return 0;
}

cVec cMuunnettuIkkuna::vektori_reaaliksi(cVec &a )
{                  //                         -1
  cMatrix apu;     // (O) x RE=Pix => RE = (O)  x Pix
  kaanna_o(apu);
  return (apu *a );
}

int cMuunnettuIkkuna::palauta(const cMatrix &A)
{
  Muunnos=A;
  return 0;
}

int cMuunnettuIkkuna::piirra_jako(const cVec &place,const int axel,const int verkko)
{
  int i; cVec apu;
  HPEN hpen=CreatePen(PS_SOLID,1,RGB(80,80,80));
  switch (axel){
    case 0: for(i=-jako;i<=jako;i++){
              apu[0]=(double)i; apu[1]=place[1]-0.2;
              if(verkko) {
                if (apu[0]==place[0]) continue;
                apu[1]=jako; luo_kyna(hpen);
                move(apu); apu[1]=-jako;
                line(apu); poista_kyna();
              }
              else {
                move(apu);
		apu[1]+=0.4;
		line(apu);
              }
	    } break;
    case 1: for(i=-jako;i<=jako;i++){
              apu[1]=(double)i; apu[0]=place[0]-0.2;
              if(verkko) {
                if (apu[1]==place[1]) continue;
                apu[0]=jako; luo_kyna(hpen);
                move(apu); apu[0]=-jako;
                line(apu); poista_kyna();
              }
              else {
                move(apu);
                apu[0]+=0.4;
	        line(apu);
              }
	    } break;
    case 2: for(i=-jako;i<=jako;i++){
              apu[0]=place[0]; apu[1]=place[1]-0.2; apu[2]=(double)i;
              if(verkko) {
                luo_kyna(hpen);
                if (apu[2]==place[2]) continue;
                apu[1]=jako;
                move(apu); apu[1]=-jako;
                line(apu);
#if 0    //jumalaton kkkkasahan tstkin tulisi??!!!! EI ky!
              int j,k;
              for (j=-jako;j<=jako;j++) {
                for (k=-jako;k<=jako;k++){
                  if (apu[2]==place[2]) continue;
                  apu[1]=j;
                  apu[0]=k;
                  move(apu); apu[1]=jako;
                  line(apu);
                }
              }
              apu[1]=(double)i;
              for (j=-jako;j<=jako;j++) {
                for (k=-jako;k<=jako;k++){
                  if (apu[1]==place[1]) continue;
                  apu[2]=j;
                  apu[0]=k;
                  move(apu); apu[2]=jako;
                  line(apu);
                }
              }
              for (j=-jako;j<=jako;j++) {
                for (k=-jako;k<=jako;k++){
                  if (apu[0]==place[0]) continue;
                  apu[0]=-jako;
                  apu[1]=j;
                  apu[2]=k;
                  move(apu); apu[0]=jako;
                  line(apu);
                }
              }
#endif
                poista_kyna();
              }
              else {
	        move(apu);
                apu[1]+=0.4;
	        line(apu);
              }
	    } break;
  }
  DeleteObject(hpen);
  return 0;
}

int cMuunnettuIkkuna::koordinaatisto(const cVec &place, int axel, HPEN kyna,const int verkko)
{
  cMatrix B;
  luo_kyna(kyna);
  switch (axel) {
    case 0:
         B=yksikkom();
         move(cVec(place[0]-(double)jako-1.0,place[1]));
         line(cVec(place[0]+(double)jako+1.0,place[1]));
         text(cVec(place[0]+(double)jako+1.0,place[1]),"x");
//           if (verkko) palauta(B);  //halutaanko muka muuttaa akselien vliset kulmatki ?!!!!
         piirra_jako(place,axel,verkko);    //HULLUTUSTA!!!!!!
//           if (!verkko) palauta(B);
         palauta(B);
         break;
    case 1:
         B=yksikkom();
         move(cVec(place[0],place[1]-(double)jako-1.0));
         line(cVec(place[0],place[1]+(double)jako+1.0));
         text(cVec(place[0],place[1]+(double)jako+1.0),"y");
//           if (verkko) palauta(B);
         piirra_jako(place,axel,verkko);
//           if (!verkko) palauta(B);
         palauta(B);
         break;
    case 2:
         B=yksikkom();
         move(cVec(place[0],place[1],place[2]-(double)jako-1.0));
         line(cVec(place[0],place[1],place[2]+(double)jako+1.0));
         text(cVec(place[0],place[1],place[2]+(double)jako+1.0),"z");
//           if (verkko)palauta(B);
         piirra_jako(place,axel,verkko);
//           if (!verkko) palauta(B);
         palauta(B);
           break;
   }
   poista_kyna();
   return 0;
}

void cMuunnettuIkkuna::luo_kyna(HPEN pen)
{
  old=(HPEN)SelectObject(hdc,pen);
}

void cMuunnettuIkkuna::poista_kyna(void)
{
  hpen=(HPEN)SelectObject(hdc,old);
}

int cMuunnettuIkkuna::Aktiivinen(void)
{
  return aktiivinen;
}

int cMuunnettuIkkuna::aseta_aktiivinen(int a)
{
  aktiivinen=a;
  return 0;
}
