#include"objekti.h"
class cKuutio:public cSateellinen{
  public:
    cKuutio(cMatrix mat=1,HPEN kyna=color[0],
            double r=1.0,cVec k=0,double kerr=1,cVec l=0):
    cSateellinen(mat,kyna,r,kerr,k,l){;}
    int piirra(cMuunnettuIkkuna A)const;  //const
    cVec oikea_yla(void);
    int aseta_loppupiste(const cVec &l);
    int tee_littea_kuutio(cVec loppup);
    cMatrix matsij(const cMatrix &C);
    cMatrix matker(const cMatrix &C);
};

/******************************************************************************/
class cEllipsi:public cSateellinen{
  public:
    cEllipsi(cMatrix mat=1,HPEN kyna=color[0],
             double r=1,cVec k=0,double kerr=1,cVec l=0):
    cSateellinen(mat,kyna,r,kerr,k,l){;}
    int piirra(cMuunnettuIkkuna A)const;  //const
};

/******************************************************************************/
class cParaabeli:public cSateellinen{
  public:
    cParaabeli(cMatrix mat=1,HPEN kyna=color[0],
               double r=0.0,cVec k=0.0,double kerr=1,cVec l=0):
    cSateellinen(mat,kyna,r,kerr,k,l){;}
    int piirra(cMuunnettuIkkuna A)const;  //const
};

/******************************************************************************/
class cYspiraali:public cSateellinen{
  public:
    cYspiraali(cMatrix mat=1,HPEN kyna=color[0],
               double r=1.0,cVec k=0,double kerr=1,cVec l=0):
    cSateellinen(mat,kyna,r,kerr,k,l){;}
    int piirra(cMuunnettuIkkuna A)const;  //const
};

/******************************************************************************/
class cZspiraali:public cSateellinen{
  public:
    cZspiraali(cMatrix mat=1,HPEN kyna=color[0],
               double r=1.0,cVec k=0,double kerr=1,cVec l=0):
    cSateellinen(mat,kyna,r,kerr,k,l){;}
    int piirra(cMuunnettuIkkuna A)const;  //const
};
/******************************************************************************/
class cViiva:public cSateellinen{
//class cViiva:public cKuutio{
  public:
    cViiva(cMatrix mat=1,HPEN kyna=color[0],
           double r=1.0,cVec alku=0,double kerr=1,cVec loppu=0):
    cSateellinen(mat,kyna,r,kerr,alku,loppu){;}
    int aseta_alkupiste(const cVec &a);
    int aseta_loppupiste(const cVec &l);
    int piirra(cMuunnettuIkkuna A)const;  //const
    cVec oikea_yla(void);
};
/******************************************************************************/
class cKolmio:public cSateellinen{
  public:
    cKolmio(cMatrix mat=1,HPEN kyna=color[0],
            double r=1.0,cVec k=0,double kerr=1,cVec l=0):
    cSateellinen(mat,kyna,r,kerr,k,l){;}
    int piirra(cMuunnettuIkkuna A)const;  //const
};
/******************************************************************************/
class cMokki:public cSateellinen{
  cKuutio Ku;
  cKolmio Ko;
  public:
    cMokki(cMatrix mat=1,HPEN kyna=color[0],
           double r=1.0,cVec k=0,double kerr=1,cVec l=0):
    cSateellinen(mat,kyna,r,kerr,k,l){
    }
    int piirra(cMuunnettuIkkuna A)const;  //const
};

#define MAX         6
#define KURSOREITA  6

typedef struct{      //Globaalit:
  HWND Hwndt[MAX];   // -muut kuin cMuunnettuIkkunat
  int dimensio;      // -mink kokoinen matriisi nkyviss
  int piirto;        // -monenko pisteen piirto
  int kuka;          // -mit kuvaa piirretn
  int lkm;           // -montako kertaa klikattu  (12.07)
  int drag_draw;     // -venytetnk laatikkoa  (12.07)
  RECT Rct;          // -pikkunan koko??
  cVec sijoitus;     // -laatikko,jonka sisn otukset piirretn
  cVec leveys;
  cSateellinen *otus;// -"piirtolaatikko"        (14.07)
  HCURSOR hcur[KURSOREITA]; //kursorit ladataan thn taulukkoon
}tGHwndt;

extern tGHwndt W;

