/*******************************************************************************
   Moduli:        vektorit.cpp
   Tarkoitus:     Luokkakirjasto vektorioperaatioille. Vektorin koko on
                  vektorit.h:ssa mritelty KOKO. Vektoriluokalla on yksi
                  yhteinen double-muuttuja laiton, joka palautetaan mm.
                  jos viitataan vrn alkioon. laiton alustetaan 0:ksi.
   Projekti:      Winlin, Cum laude approbatur -harjoitusty
   Tekijt:       Virpi Kivinen & Tiina Mkinen
   Tehty:         1.1.96
   Muutettu       1.7.96
   Mit muutettu: + listtyyt
   Puutteet:

  cVec-luokan metodit:
   - double &cVec::operator[](int i)
       palauttaa arvon vektorin paikasta i; palauttaa laittoman,
       jos viittaus on vr
   - const double &cVec::operator[](int i) const
   - int cVec::operator==(const cVec &y) const
       vektorien vertailu: palauttaa 1, jos samat, muuten palauttaa 0:n
   - cVec &cVec::operator=(const cVec &y)
       vektorin sijoitus vektorille
   - double cVec::operator*(const cVec &y) const
       palauttaa vektorien sistulon
   - cVec &cVec::operator*(const double r)
       vektori*reaaliluku, palauttaa kerotun vektorin

*******************************************************************************/
#include<windows.h>
#include<windowsx.h>
#include"vektorit.h"

double cVec::laiton=0;

double &cVec::operator[](int i)
{
  if (i<0||KOKO<=i){
    return laiton;
  }
  return x[i];
}

const double &cVec::operator[](int i) const
{
  if (i<0||KOKO<=i){
    return laiton;
  }
  return x[i];
}

int cVec::operator==(const cVec &y) const
{
  int i,virhe=0;
  for(i=0;i<KOKO;i++) if (x[i]==y.x[i]) virhe++;
  return (virhe==KOKO);
}

cVec &cVec::operator=(const cVec &y)    //vektorin sijoitus vektorille
{
  int i;
  if (*this==y) return *this;
  for(i=0;i<KOKO;i++) x[i]=y.x[i];
  return *this;
}

double cVec::operator*(const cVec &y) const  //vektorien sistulo
{
  int i; double sum=0.0;
  for(i=0;i<KOKO;i++) sum+=x[i]*y.x[i];
  return sum;
}

cVec &cVec::operator*(const double r)   //vektori*reaaliluku
{
  int i;
  for (i = 0; i<KOKO; i++) x[i] *= r;
  return  *this;
}

